#include <stdio.h>

typedef struct {
  int xmin, xmax, ymin, ymax;
  int numbernum;
} SLIDE;

typedef struct {
  int x,y;
  int determined;
} NUMBER;

int main() {
  int i,f,n;
  int d1,d2,d3,d4;
  int heap=1;
  int changed, all_done;
  
  SLIDE *slides=NULL;
  NUMBER *numbers=NULL;

 while(1) {
//  printf("\n\n\n");
  scanf("%d", &n);
  if (n==0)
    break;
  if (slides!=NULL)
    free(slides);
  if (numbers!=NULL)
    free(numbers);
  slides=(SLIDE *) malloc(n*sizeof(SLIDE));
  numbers=(NUMBER *) malloc(n*sizeof(NUMBER));
  
  for (i=0; i<n; i++) {
    scanf("%d %d %d %d", &d1, &d2, &d3, &d4);
    slides[i].xmin=d1;
    slides[i].xmax=d2;
    slides[i].ymin=d3;
    slides[i].ymax=d4;
    slides[i].numbernum=-1;
   // slides[i].slidenum=-1;
//    printf("slides[%d]: %d %d %d %d   %d\n", i,slides[i].xmin,slides[i].xmax,slides[i].ymin,slides[i].ymax,slides[i].numbernum);
  }
  
  for (i=0; i<n; i++) {
    scanf("%d %d", &d1, &d2);
    numbers[i].x=d1;
    numbers[i].y=d2;
    //numbers[i].slidenum=-1;
    numbers[i].determined=0;
   //  numbers[i].letter='A'+i;
//   printf("numbers[%d]: %d %d   %d\n", i,numbers[i].x, numbers[i].y, numbers[i].determined);
  }
  
  printf("Heap %d\n", heap++);

 all_done=0;
 changed=1;
 while(changed) {
  changed=0;
  for (i=0; i<n; i++) { //slides
    if (slides[i].numbernum!=-1)
      continue;
    d1=0;
    d2=-1;
    for (f=0; f<n; f++) { //numbers
      if (numbers[f].determined==0 && numbers[f].x>slides[i].xmin && numbers[f].x<slides[i].xmax && numbers[f].y>slides[i].ymin && numbers[f].y<slides[i].ymax) {
          d1++;
          d2=f;
      }
    }
    
//    printf("Debug: slides[%d] & numbers[%d]: d1=%d   d2=%d\n", i,f, d1,d2);
    
    if (d1==1) {
      slides[i].numbernum=d2;
      numbers[d2].determined=1;
      changed=1;
      all_done++;
      //numbers[d2].slidenum=i;
    }
  }
 }
  
  if (all_done==0)
    printf("none\n\n");
  else {
    for (i=0; i<n; i++) {
      if (slides[i].numbernum!=-1) {
        printf("(%c,%d) ", 'A'+i, slides[i].numbernum+1);
      }
    }
    printf("\n\n");
  }
 }
}